## Node

What is Node?

What is NPM?

What is the `package.json` file?

What is the `node_modules` folder?

Why shouldn't you ever push `node_modules` to a repository?

What does the `npm install` command do?

What does `npm update` do?

## TypeScript

What is TypeScript?

What is the file extension for a TypeScript file?

What are the benefits of TypeScript over vanilla JavaScript?

What is the `any` type in TypeScript?

What are the access modifiers in TypeScript?

What is the syntax for setting a type (for a variable or method) in TypeScript?

What happens when you add an access modifier to a constructor parameter (like below)?
```
    public class MyClass {
        public MyClass(private myService: MyService) { }
    }
```

What is a decorator?

## Angular

What is Angular?

What is a SPA? What are the benefits of this architecture?

What is the difference between AngularJS and Angular (2+)?

Describe these Angular CLI commands:
`ng new`
`ng serve`
`ng build`
`ng generate`/`ng g`
`ng test`

What is a directive? What are the 3 different types?

What is a module?

What is a component?

What metadata goes in a `@Component` decorator?

What are the four files that are created after running `ng g c component-name`? Describe each briefly.

What metadata goes in an `@NgModule` decorator?

What is binding? What are the four different types plus syntax for each?

Give an example of when you would use each type of binding.

What is a pipe?

How do you make a custom pipe?

What is necessary in the app module in order to use two-way binding for inputs?

What is meant by "app module" and "app component"?

What is the benefit of using components?

What is routing?

How do we set up routing in Angular?

What are services in Angular?

What decorator is used in Angular service classes?

What is dependency injection? How do we set it up in Angular?

What is HttpClient?

When/why use HttpClient over Fetch API or AJAX (and by extension, why use Observables over Promises)?